functions 4.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150
  1. #!/usr/bin/env bash
  2. export ZWAVE_JS_CONF="${SNAP}/lib/node_modules/zwavejs2mqtt/node_modules/@zwave-js/config"
  3. function ensure_zwavejs_config {
  4. # Not needed anymore as of ZWAVEJS_EXTERNAL_CONFIG
  5. # if [ "$(find ${ZWAVE_JS_CONF} -maxdepth 0 -empty -exec echo empty \;)" == "empty" ]; then
  6. # logger "Config directory is empty, copying data from ${SNAP}/snap/zwave-js/config"
  7. # rsync -raz "${SNAP}/snap/zwave-js/config" "${ZWAVE_JS_CONF}/.."
  8. # else
  9. # logger "Config directory ${ZWAVE_JS_CONF} exists"
  10. # fi
  11. return 0
  12. }
  13. function get_network_key {
  14. if [ -f "${SNAP_DATA}/settings.json" ]; then
  15. SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  16. if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  17. echo "${SETTINGS_KEY}"
  18. return 1
  19. fi
  20. return 0
  21. fi
  22. return 0
  23. }
  24. function same_network_key {
  25. # SKIP NOW: NETWORK KEY SHOULD NOT BE USED
  26. # FAVOR SETTING
  27. # if [ -f "${SNAP_DATA}/settings.json" ]; then
  28. # SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  29. # if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  30. # echo "${SETTINGS_KEY}"
  31. # return 1
  32. # fi
  33. # return 0
  34. # fi
  35. return 0
  36. }
  37. function plug_connected {
  38. if ! snapctl is-connected "${1}"; then
  39. echo "Missing plug: «${1}»" >&2
  40. echo "Connect with:"
  41. if [ "${1}" == "serial-port" ]; then
  42. echo "$ sudo snap connect ${SNAP_NAME}:${1} <slot name>"
  43. else
  44. echo "$ sudo snap connect ${SNAP_NAME}:${1}"
  45. fi
  46. return 1
  47. fi
  48. return 0
  49. }
  50. function plugs_connected {
  51. MISSING=0
  52. RAW_OUT=$(plug_connected "raw-usb")
  53. RAW_RES=$?
  54. SERIAL_OUT=$(plug_connected "serial-port")
  55. SERIAL_RES=$?
  56. if [ $RAW_RES -ne 0 -a $SERIAL_RES -ne 0 ]; then
  57. echo $RAW_OUT
  58. echo "----- OR -----"
  59. echo $SERIAL_OUT
  60. echo "See ${SNAP_NAME}.help for more info on the serial-port plug"
  61. MISSING=1
  62. fi
  63. plug_connected "hardware-observe"
  64. if [ $? -ne 0 ]; then
  65. MISSING=1
  66. fi
  67. if [ $MISSING -ne 0 ]; then
  68. return 1
  69. fi
  70. return 0
  71. }
  72. function is_root {
  73. if [ ${EUID:-$(id -u)} -eq 0 ]; then
  74. return 0
  75. fi
  76. return 1
  77. }
  78. function require_root {
  79. is_root
  80. if [ $? -eq 1 ]; then
  81. echo "Running as root is required." >&2
  82. echo "Re-run with sudo."
  83. exit 1
  84. fi
  85. }
  86. function testnset_config {
  87. logger "${SNAP_NAME}: Testing ${1}, or setting ${2}"
  88. RES=$(snapctl get ${1})
  89. if [ $? -ne 0 ] || [ -z "${RES}" ]; then
  90. logger "${SNAP_NAME}: Setting ${1}=${2}"
  91. RES=$(snapctl set ${1}=${2})
  92. if [ $? -ne 0 ]; then
  93. logger "${RES}"
  94. exit 1
  95. fi
  96. return 0
  97. fi
  98. return 0
  99. }
  100. function test_priority_dir {
  101. Z2M_SETTINGS="${SNAP_DATA}/settings.json"
  102. if ! [ -w "${Z2M_SETTINGS}" ]; then
  103. return 1
  104. fi
  105. PRIORITY_DIR=$(echo "$(sed -E "s#$(dirname ${SNAP_DATA})/(current|[0-9]+)#${SNAP_DATA}#g" <<< $(cat "${Z2M_SETTINGS}" | jq '.zwave.deviceConfigPriorityDir'))" | tr -d '"')
  106. if [[ -d $(dirname "${PRIORITY_DIR}") && -w "${PRIORITY_DIR}" ]]; then
  107. jq --arg deviceConfigPriorityDir ${PRIORITY_DIR} '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  108. if [ $? -eq 0 ]; then
  109. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  110. fi
  111. elif ! [[ "${PRIORITY_DIR}" =~ ^"$(dirname $SNAP_DATA)"* ]]; then
  112. jq --arg deviceConfigPriorityDir "${SNAP_DATA}/devicePriorityConfig" '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  113. if [ $? -eq 0 ]; then
  114. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  115. fi
  116. fi
  117. return 0
  118. }
  119. function test_default_config {
  120. testnset_config "server.host" "localhost"
  121. testnset_config "server.port" 8091
  122. testnset_config "server.ssl" false
  123. testnset_config "server.force-disable-ssl" false
  124. testnset_config "session.cookie-secure" $(snap get server.ssl)
  125. testnset_config "session.secret" $(uuid)
  126. testnset_config "mqtt.name" ""
  127. }